<template>
  <v-container>
    <v-form ref="form" v-model="valid" lazy-validation>

      <h2 class="text-h3 my-5">Оставьте заявку на обратный звонок</h2>

      <v-alert v-if="isShowAlert" type="success" class="mb-5">Мы вам скоро позвоним!</v-alert>

      <v-text-field v-model="name" :counter="10" :rules="nameRules" label="Ваше имя" required class="mb-2"></v-text-field>

      <v-text-field v-model="phone" :rules="phoneRules" label="Ваш номер телефона" required class="mb-2"></v-text-field>

      <v-btn color="success" class="mr-4" @click.prevent="postOrder">
        Отправить
      </v-btn>


    </v-form>
  </v-container>
</template>

<script>
export default {
  data: () => ({
    isShowAlert: false,
    valid: true,
    name: '',
    nameRules: [
      v => !!v || 'Name is required',
      v => (v && v.length <= 10) || 'Name must be less than 10 characters',
    ],
    phone: '',
    phoneRules: [
      v => !!v || 'Phone is required',
      v => /^((\+7|7|8)+([0-9]){10})$/.test(v) || 'Phone must be valid',
    ],
    checkbox: false,
  }),

  methods: {
    async postOrder() {
      const { valid } = await this.$refs.form.validate()
      if (valid) {
        this.isShowAlert = true;
        setTimeout(() => {
          this.isShowAlert = false;
        }, 3000);
        this.$store.dispatch('postOrder', {
          name: this.name,
          phone: this.phone,
        });
        setTimeout(() => {
          this.isShowAlert = false;
          this.checkbox = false;
          this.name = '';
          this.phone = '';
          this.reset();
          this.resetValidation();
          this.$router.push('/');
        }, 3000);
      }
    },
    reset() {
      this.$refs.form.reset()
    },
    resetValidation() {
      this.$refs.form.resetValidation()
    },
  },
}
</script>
